package jdk.internal.util.xml.impl;

import jdk.internal.org.xml.sax.Attributes;

public class Attrs implements Attributes
{
    String[] mItems;
    private char mLength;
    private char mAttrIdx;
    
    public Attrs() {
        this.mAttrIdx = '\0';
        this.mItems = new String[64];
    }
    
    public void setLength(char mLength) {
        if (mLength > (char)(this.mItems.length >> 3)) {
            this.mItems = new String[mLength << 3];
        }
        this.mLength = mLength;
    }
    
    @Override
    public int getLength() {
        return this.mLength;
    }
    
    @Override
    public String getURI(int n) {
        return (n >= 0 && n < this.mLength) ? this.mItems[n << 3] : null;
    }
    
    @Override
    public String getLocalName(int n) {
        return (n >= 0 && n < this.mLength) ? this.mItems[(n << 3) + 2] : null;
    }
    
    @Override
    public String getQName(int n) {
        if (n < 0 || n >= this.mLength) {
            return null;
        }
        return this.mItems[(n << 3) + 1];
    }
    
    @Override
    public String getType(int n) {
        return (n >= 0 && n < this.mItems.length >> 3) ? this.mItems[(n << 3) + 4] : null;
    }
    
    @Override
    public String getValue(int n) {
        return (n >= 0 && n < this.mLength) ? this.mItems[(n << 3) + 3] : null;
    }
    
    @Override
    public int getIndex(String anObject, String anObject2) {
        int mLength = this.mLength;
        int i = '\0';
        while (i < mLength) {
            if (this.mItems[i << 3].equals(anObject) && this.mItems[(i << 3) + 2].equals(anObject2)) {
                return i;
            }
            i = (char)(i + 1);
        }
        return -1;
    }
    
    int getIndexNullNS(String anObject, String s) {
        int mLength = this.mLength;
        if (anObject != null) {
            int j = '\0';
            while (j < mLength) {
                if (this.mItems[j << 3].equals(anObject) && this.mItems[(j << 3) + 2].equals(s)) {
                    return j;
                }
                j = (char)(j + 1);
            }
        }
        else {
            int i = '\0';
            while (i < mLength) {
                if (this.mItems[(i << 3) + 2].equals(s)) {
                    return i;
                }
                i = (char)(i + 1);
            }
        }
        return -1;
    }
    
    @Override
    public int getIndex(String anObject) {
        int mLength = this.mLength;
        int i = '\0';
        while (i < mLength) {
            if (this.mItems[(i << 3) + 1].equals(anObject)) {
                return i;
            }
            i = (char)(i + 1);
        }
        return -1;
    }
    
    @Override
    public String getType(String s, String s2) {
        int index = this.getIndex(s, s2);
        return (index >= 0) ? this.mItems[(index << 3) + 4] : null;
    }
    
    @Override
    public String getType(String s) {
        int index = this.getIndex(s);
        return (index >= 0) ? this.mItems[(index << 3) + 4] : null;
    }
    
    @Override
    public String getValue(String s, String s2) {
        int index = this.getIndex(s, s2);
        return (index >= 0) ? this.mItems[(index << 3) + 3] : null;
    }
    
    @Override
    public String getValue(String s) {
        int index = this.getIndex(s);
        return (index >= 0) ? this.mItems[(index << 3) + 3] : null;
    }
    
    public boolean isDeclared(int n) {
        if (n < 0 || n >= this.mLength) {
            throw new ArrayIndexOutOfBoundsException("");
        }
        return this.mItems[(n << 3) + 5] != null;
    }
    
    public boolean isDeclared(String s) {
        int index = this.getIndex(s);
        if (index < 0) {
            throw new IllegalArgumentException("");
        }
        return this.mItems[(index << 3) + 5] != null;
    }
    
    public boolean isDeclared(String s, String s2) {
        int index = this.getIndex(s, s2);
        if (index < 0) {
            throw new IllegalArgumentException("");
        }
        return this.mItems[(index << 3) + 5] != null;
    }
    
    public boolean isSpecified(int n) {
        if (n < 0 || n >= this.mLength) {
            throw new ArrayIndexOutOfBoundsException("");
        }
        String s = this.mItems[(n << 3) + 5];
        return s == null || s.charAt(0) == 'd';
    }
    
    public boolean isSpecified(String s, String s2) {
        int index = this.getIndex(s, s2);
        if (index < 0) {
            throw new IllegalArgumentException("");
        }
        String s3 = this.mItems[(index << 3) + 5];
        return s3 == null || s3.charAt(0) == 'd';
    }
    
    public boolean isSpecified(String s) {
        int index = this.getIndex(s);
        if (index < 0) {
            throw new IllegalArgumentException("");
        }
        String s2 = this.mItems[(index << 3) + 5];
        return s2 == null || s2.charAt(0) == 'd';
    }
}
